'trimasakari.bas - video benchmark, written by Kaze, rev.1, use "-O3 -ffast-math -msse4.2 -maes"
DefLng A-Z
'dest_handle = _NewImage(1200, 2 * 330 + 12, 32) '672/16=42; 1200/8=150
'Screen dest_handle
FontH = 16
FontW = 8

''Screen 12 'text characters are 8 X 16 pixel blocks
dest_handle = _NewImage(256 * 8, 16, 256) '672/16=42; 1200/8=150
Screen dest_handle
Dim Shared Font01(0 To 255, 0 To 15) As String * 1 'store data by character row byte values
GetTextShape 'call to SUB at start of program
For i = 0 To 255
    DrawTextShape 1, i + 1, i, i
Next
'Sleep
'End

ReDim source_handle1(1 To 19)
For i = 1 To 19
    q$ = LTrim$(Str$(i))
    If i <= 9 Then q$ = "0" + q$
    source_handle1(i) = _LoadImage("warwalk_30hue_x3_NearestNeighbor" + q$ + ".gif", 32)
Next

ReDim source_handle2(1 To 19)
For i = 1 To 19
    q$ = LTrim$(Str$(i))
    If i <= 9 Then q$ = "0" + q$
    source_handle2(i) = _LoadImage("warwalk_152hue-52sat_x3_NearestNeighbor" + q$ + ".gif", 32)
Next

dx1 = 0: dy1 = 0
dx2 = _Width(source_handle1(1)) - 1: dy2 = _Height(source_handle1(1)) - 1

CharsPerLine = 3 * dx2 \ FontW + 1
NumOfLines = 2 * dy2 \ FontH + 1

dest_handle = _NewImage(CharsPerLine * FontW, NumOfLines * FontH, 32) '672/16=42; 1200/8=150
Do: Loop Until _ScreenExists
Screen dest_handle
_ScreenMove 102, 3
_Title "Trimasakari; use 'B' to toggle benchmark/delayed mode"

PauseFlag = Not 0
Stp = 6
FirstFrame1_1 = 1
FirstFrame1_2 = 12
FirstFrame1_3 = 7
FirstFrame2_1 = 9
FirstFrame2_2 = 2
FirstFrame2_3 = 16
VirtualB = 0 - dx2
VirtualE = CharsPerLine * FontW + 3 * dx2
ScrolledT = 1
Once = 1
Do

    If PauseFlag Then
        Stp = 6
        MAX_FPS_HD = 0
    Else
        Stp = 9 - 3
        FPS_HD = 0
        td1# = Timer(.001)
    End If

    For j = VirtualB To VirtualE
        IncomingKey$ = InKey$
        If IncomingKey$ <> "" Then
            If (IncomingKey$) = Chr$(27) Then Exit Do
            If UCase$(IncomingKey$) = "B" Then
                PauseFlag = Not PauseFlag
            End If
            If PauseFlag Then
                Stp = 6
                MAX_FPS_HD = 0
            Else
                Stp = 9 - 3
                FPS_HD = 0
                td1# = Timer(.001)
            End If
            Do: Loop While InKey$ <> ""
        End If
        Color _RGB32(40, 40, 20)
        For i = 1 To NumOfLines - 1
            Locate i, 1
            Print String$(CharsPerLine, Chr$(177));
        Next
        Locate NumOfLines, 1
        Print String$(CharsPerLine, Chr$(177));
        Locate NumOfLines, 1
        Color _RGB32(&H54, &H54, &HFC)

        ''"This line is to be written with dynamic 8x16 or 8x14 font (rendered by my API)..."
        ScrolledText$ = String$(CharsPerLine, Chr$(32)) + "Trimasakari; use Alt+Enter to toggle fullscreen/window mode; use 'B' to toggle benchmark/delayed mode; MAX Speed: " + AddZeroes$(MAX_FPS_HD) + " Frames-Per-Second" + String$(CharsPerLine, Chr$(32))
        ''pad it with spaces and move it left-to-right, one char at a time:
        ''Print Mid$(ScrolledText$, ScrolledT, CharsPerLine);
        '_PrintString ((1 - 1), (NumOfLines - 1) * 16), Mid$(ScrolledText$, ScrolledT, CharsPerLine)
        'If CharsPerLine + Len("Trimasakari; use Alt+Enter to toggle fullscreen/window mode; use 'B' to toggle benchmark/delayed mode; MAX Speed: " + AddZeroes$(MAX_FPS_HD) + " Frames-Per-Second") < ScrolledT Then ScrolledT = 0
        'ScrolledT = ScrolledT + 1

        qqq = Len(ScrolledText$)
        If Abs(zzz) > qqq * 8 - CharsPerLine * 8 Then zzz = 0
        _PrintString (zzz, (NumOfLines - 1) * 16), ScrolledText$ '-1 in order to position in upper left
        zzz = zzz - 1

        _PutImage (dx1 + j - 1 * dx2, dy1)-(dx2 + j - 1 * dx2, dy2), source_handle1(FirstFrame1_1), dest_handle
        _PutImage (dx1 + j - 2 * dx2, dy1)-(dx2 + j - 2 * dx2, dy2), source_handle1(FirstFrame1_2), dest_handle
        _PutImage (dx1 + j - 3 * dx2, dy1)-(dx2 + j - 3 * dx2, dy2), source_handle1(FirstFrame1_3), dest_handle

        _PutImage (dx1 + j - 0 * dx2, dy1 + _Height(source_handle1(1)))-(dx2 + j - 0 * dx2, dy2 + _Height(source_handle1(1))), source_handle2(FirstFrame2_1), dest_handle
        _PutImage (dx1 + j - 1 * dx2, dy1 + _Height(source_handle1(1)))-(dx2 + j - 1 * dx2, dy2 + _Height(source_handle1(1))), source_handle2(FirstFrame2_2), dest_handle
        _PutImage (dx1 + j - 2 * dx2, dy1 + _Height(source_handle1(1)))-(dx2 + j - 2 * dx2, dy2 + _Height(source_handle1(1))), source_handle2(FirstFrame2_3), dest_handle

        j = j + Stp
        FirstFrame1_1 = FirstFrame1_1 + 1
        If FirstFrame1_1 > 19 Then FirstFrame1_1 = 1
        FirstFrame1_2 = FirstFrame1_2 + 1
        If FirstFrame1_2 > 19 Then FirstFrame1_2 = 1
        FirstFrame1_3 = FirstFrame1_3 + 1
        If FirstFrame1_3 > 19 Then FirstFrame1_3 = 1

        FirstFrame2_1 = FirstFrame2_1 + 1
        If FirstFrame2_1 > 19 Then FirstFrame2_1 = 1
        FirstFrame2_2 = FirstFrame2_2 + 1
        If FirstFrame2_2 > 19 Then FirstFrame2_2 = 1
        FirstFrame2_3 = FirstFrame2_3 + 1
        If FirstFrame2_3 > 19 Then FirstFrame2_3 = 1

        _Display
        FPS_HD = FPS_HD + 1
        If PauseFlag Then _Delay .06
    Next

    If Once Then _FullScreen _Stretch , _Smooth
    Once = 0
    If PauseFlag Then
        _Title "Trimasakari; use 'B' to toggle benchmark/delayed mode"
    Else
        td2# = Timer(.001)
        FPS_HD_report = FPS_HD \ (td2# - td1# + 1)
        If MAX_FPS_HD < FPS_HD_report Then MAX_FPS_HD = FPS_HD_report
        _Title "Trimasakari; use 'B' to toggle benchmark/delayed mode; Current/MAX Speed: " + AddZeroes$(FPS_HD_report) + "/" + AddZeroes$(MAX_FPS_HD) + " Frames-Per-Second"
    End If
    _Limit 1000
Loop
System

Function AddZeroes$ (UpTo999)
    Padded$ = LTrim$(Str$(UpTo999))
    Select Case Len(Padded$)
        Case 1
            Padded$ = "00" + Padded$
        Case 2
            Padded$ = "0" + Padded$
        Case Else
    End Select
    AddZeroes$ = Padded$
End Function

Sub DrawTextShape (Trow, Tcol, FG, ASCode) 'displays ASCII character value from array
    Srow = 16 * (Trow - 1): Scol = 8 * (Tcol - 1) 'convert text to graphic coordinates
    For y = 0 To 15
        ybyte$ = Font01$(ASCode, y): yval = Asc(ybyte$)
        For x = 0 To 7
            If (yval And 2 ^ x) > 0 Then PSet (Scol + x, Srow + y), FG
        Next
    Next
End Sub

Sub GetTextShape
    'Out &H3C8, 1: Out &H3C9, 0: Out &H3C9, 0: Out &H3C9, 0 'print text as background color
    'Color 1 'hide the character printing
    For ascii% = 0 To 255 'Draw map of each character
        _PrintString (0, 0), Chr$(ascii%) 'PRINT ASCII characters to top left corner
        For row% = 0 To 15 'read 16 row byte values
            byte = 0 'reset value every row
            For col% = 7 To 0 Step -1 'read 8 pixels from right to left
                byte = byte * 2 - (Point(col%, row%) > 0) 'bit-packing with 2 ^ bit
            Next
            Font01(ascii%, row%) = Chr$(byte) 'convert row byte value to ASCII character
        Next
    Next
    'Palette 'restore all palette colors
End Sub

